#version 430 core

layout(points) in; //points in
layout(triangle_strip, max_vertices = 4) out; //quads out

uniform mat4 ProjectionMatrix;

//from vertex shader
in vData{
	float TTL1;
	//TODO: additional vertex data goew here!
} vertex[];

out vec2 TexCoord0;
flat out float TTL0; //flat = no interpolation between vertices

void main(void)
{    
    const vec2 size = vec2(0.1,0.1); //size of the particle quads
	
	for(int i = 0; i<gl_in.length();i++){
		vec4 P = gl_in[i].gl_Position; //position in view-space

		//bottom-left corner
		vec2 va = P.xy + vec2(-0.5,-0.5) * size; //bottom-left corner
		gl_Position = ProjectionMatrix * vec4(va,P.zw);
		TexCoord0 = vec2(0.0,0.0);
		TTL0 = vertex[i].TTL1;
		EmitVertex();

		//bottom-right corner
		va = P.xy + vec2(0.5,-0.5) * size;
		gl_Position = ProjectionMatrix * vec4(va,P.zw);
		TexCoord0 = vec2(0.0,1.0);
		EmitVertex();

		//top-left corner
		va = P.xy + vec2(-0.5,0.5) * size;
		gl_Position = ProjectionMatrix * vec4(va,P.zw);
		TexCoord0 = vec2(1.0,0.0);
		EmitVertex();

		//top-right corner
		va = P.xy + vec2(0.5,0.5) * size;
		gl_Position = ProjectionMatrix * vec4(va,P.zw);
		TexCoord0 = vec2(1.0,1.0);
		EmitVertex();

		EndPrimitive();
	}
}