#version 430 core
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 out_normal;
out vec3 FragPos;
out vec2 UV;

layout(location = 3)uniform mat4 modelMatrix;
layout(location=4)uniform mat4 viewProjMatrix;

void main() {
	gl_Position = viewProjMatrix*modelMatrix*vec4(position,1.0f);
	out_normal = mat3(transpose(inverse(modelMatrix)))*normal;
	UV = uv;
	FragPos = vec3(modelMatrix * vec4(position,1.0f));
}